<template>
    <div>
        <form @submit.prevent="submit" ref="form">
            <select-plan :plans="plans" v-model="form.plan_id" @currency-update="setCurrency" :is_error="errors.has('plan_id')"></select-plan>
            <div class="form-group">
                <label for="currency_id_field">{{ $t('cabinet.invest.form.currency') }}</label>
                <select
                    v-model="form.currency_id" v-validate="'required|numeric|min_value:1'" data-vv-as="Валюта" :class="hasErrorCurrency"
                    class="form-control" name="currency_id" id="currency_id_field" >
                        <option v-for="currency in currencies" :key="currency.id" :value="currency.id" :selected="currency.id === form.currency_id">{{ currency.code_iso }}</option>
                </select>
            </div>
            <div class="form-group">
                <label for="amount_field">{{ $t('cabinet.invest.form.amount') }}</label>
                <input
                    v-model="form.amount" v-validate="'required|decimal:5|min_value:0.00001'" data-vv-as="Сумма" :class="hasErrorAmount"
                    type="number" class="form-control" name="amount" id="amount_field" step="0.00001">
            </div>
            <div class="form-group" v-if="balance_type === 'divided'">
                <label for="wallet_id_field">{{ $t('cabinet.invest.form.wallet') }}</label>
                <select
                    v-model="form.wallet_id" v-validate="'required|numeric|min_value:1'" data-vv-as="Кошелек" :class="hasErrorWallet"
                    class="form-control" name="wallet_id" id="wallet_id_field" >
                    <option v-for="wallet in wallets" :key="wallet.id" :value="wallet.id" :selected="wallet.id === form.wallet_id">{{ wallet.payment_system.name }}</option>
                </select>
            </div>
            <button class="btn btn-primary" type="submit">{{ $t('cabinet.invest.form.submit') }}</button>
        </form>
    </div>
</template>

<script>
    import axios from 'axios';

	export default {
		props: ['action_url', 'redirect_url', 'plans', 'wallets', 'balance_type', 'currencies', 'old'],
        components: {
			'select-plan': require('./SelectPlan').default
        },
        mixins: [
        	require('./../../mixins/vee-laravel-validation').default
        ],
        data(){
			return {
				form: {
					amount: this.old ? this.old.amount : 0,
                    plan_id: this.old ? this.old.plan_id : 0,
                    currency_id: this.old ? this.old.currency_id : 0,
                    wallet_id: this.old ? this.old.wallet_id : 0,
                }
            }
        },
        created(){
			let uri = window.location.search.substring(1);
			if(uri){
                let params = new URLSearchParams(uri);
                let plan_id = params.get("plan_id");
                if(plan_id){
                	this.form.plan_id = this.form.plan_id ? this.form.plan_id : Number.parseInt(plan_id);
                }
            }
        },
        computed: {
			hasErrorCurrency(){
				return {
					'is-invalid': this.errors.has('currency_id')
				};
            },
			hasErrorWallet(){
				return {
					'is-invalid': this.errors.has('wallet_id')
				};
            },
			hasErrorAmount(){
				return {
					'is-invalid': this.errors.has('amount')
				};
            }
        },
        methods: {
			submit(){
				if (this.$refs.form.checkValidity()) {
					this.save();
				} else {
					this.$refs.form.reportValidity();
				}
            },
			save(){
                axios.post(this.action_url, this.form)
                    .then(({data}) => {
                    	if(data.status === 'success'){
                    		//this.$toasted.success('Success');
                            window.location = this.redirect_url;
                        }else{
							this.$toasted.error(data.message);
						}
                    })
                    .catch(err => {
                        this.$setLaravelValidationErrorsFromResponse(err.response.data);
                    });
            },
            setCurrency(currency_id){
				this.form.currency_id = currency_id;
            }
        }
	}
</script>

<style scoped>

</style>
